/*******************************************************************************
*  skST7735x_img - ST7735`bvTFT-LCDp֐Cu(C[Wf[^o͕) *
*                  ST7735R/S`bv(ΐF^u)̂݊mF                 *
*                  (̃CúASDJ[hgp܂B)                  *
*                                                                              *
*    IMG_imgInit        - C[Wo͊֘A(SPI)̏s              *
*    IMG_PutImage       - alo摜\鏈                           *
*    IMG_PutcK          - w肳ꂽʒuɊP(12x12)`悳鏈      *
*    IMG_PutsK          - w肳ꂽʒuɊ(12x12)`悳鏈    *
*                                                                              *
*    \ɂ́A"SHINOME.PDB"t@CKvłB                           *
*    SDJ[hCS(SPI)sw"skSDlib.h"ōsėL܂B                  *
*                                                                              *
* ============================================================================ *
*   VERSION  DATE        BY             CHANGE/COMMENT                         *
* ---------------------------------------------------------------------------- *
*   1.00     2019-05-15  ޒH[     Create                                 *
*   1.10     2019-06-04  ޒH[     ɓǂݏolɑΉ               *
* ============================================================================ *
*  PIC 24EP256MC202 24FJ64GB002 18F26K22                                       *
*  MPLAB X(v5.15)                                                              *
*  MPLAB(R) XC8  C Compiler Version 1.40                                       *
*  MPLAB(R) XC16 C Compiler Version 1.30                                       *
*******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "skSDlib.h"
#include "skST7735x.h"
#include "skST7735x_img.h"


/*******************************************************************************
*  ans= IMG_imgInit()                                                          *
*    C[Wo͊֘A(SD)̏s                                    *
*    ans  : 큁O  ُ큁OȊÕG[R[hl                             *
*******************************************************************************/
uint16_t IMG_imgInit()
{
     uint16_t ans ;

     // rcJ[h̏
     ans = SD_Init() ;

     return ans ;
}
/*******************************************************************************
*  ans = IMG_PutImage(xp,yp,*filename)                                         *
*    alo摜\鏈                                                *
*    Windows24rbgJ[̂ݑΉ                                           *
*    xp        : fBXvCW̗()Jnʒu                              *
*    yp        : fBXvCW̍s(c)Jnʒu                              *
*    *filename : alõt@C(p啶)                                *
*    ans       : 0=I                                                    *
*                1=t@CI[vG[(t@C݂Ȃ)            *
*                2=BMPt@CłȂ́A24rbgJ[łȂ                 *
*******************************************************************************/
uint16_t IMG_PutImage(uint16_t xp, uint16_t yp, const char *filename)
{
     struct SDFILE_OBJECT fds ;
     struct BMP_HEADER    hed ;
     uint8_t  sp, l, x, y ;
     char     rgb[3] ;
     uint16_t ans ;

     // t@C̓Ǎ݃I[v
     ans = SD_Open(&fds,filename,O_READ) ;
     if (ans == 0) {
          // t@C̃wb_ǂݏo
          SD_Read(&fds,(char *)&hed,sizeof(hed)) ;
          // 摜f[^ǂݏo
          if ((hed.ImageType1 == 'B')&&(hed.ImageType2 == 'M')&&(hed.PixelColorNum == 24)) {
               // \Jnʒu()̐ݒ
               // BMPt@C͉摜f[^㉺΂ɋL^Ă
               x = xp ;
               l = (hed.ImageWidth-1) + xp ;
               y = yp + (hed.ImageHeight-1)  ;
               // ̃f[^͂S̔{PʂœZ߂ėL
               sp = 4 - ((hed.ImageWidth*3) % 4) ;
               if (sp == 4) sp = 0 ;
               // `͈͂1Cw肷
               LCD_RangSET(xp,l,y,y) ;
               LCD_SendByte(ST7735X_CMD_RAMWR,ST7735X_COMMAND) ;
               // 摜f[^̏ꏊ܂ŃV[N
               SD_Seek(&fds,hed.HeaderSize,1) ;
               while (1) {
                    // RoCg(B,G,R)ǂݏo܂
                    ans = SD_SEQRead(&fds,rgb,3) ;
                    if (ans != 3) break ;
                    // FĐFݒ肷
                    LCD_ReduceColorSet(rgb[2],rgb[1],rgb[0]) ;
                    // 1hbg`
                    LCD_SendByte(RGB[0],ST7735X_PARAMETER) ;
                    LCD_SendByte(RGB[1],ST7735X_PARAMETER) ;
                    LCD_SendByte(RGB[2],ST7735X_PARAMETER) ;
                    x++ ;
                    if (x > l) {
                         // S{ɑȂ͂OŖ߂ėL̂œǂݎ̂Ă
                         if (sp != 0) SD_SEQRead(&fds,rgb,sp) ;
                         // ̍sɈڂ
                         y-- ;
                         x = xp ;
                         // `͈͂1Cw肷
                         LCD_RangSET(xp,l,y,y) ;
                         LCD_SendByte(ST7735X_CMD_RAMWR,ST7735X_COMMAND) ;
                    }
               }
               ans = 0 ;
          } else ans = 2 ;    // BMPt@CłȂ́A24rbgJ[łȂ
          // t@C̃N[Y
          SD_Close(&fds) ;
     } else {
          // t@C̃I[vG[
          // t@C݂ȂꍇG[łB
          ans = 1 ;
     }
     return ans ;
}
/*******************************************************************************
*  ans = IMG_PutcK(xp,yp,c)                                                    *
*    w肳ꂽʒuɊP(12x12)`悳鏈                           *
*    SDJ[htHgf[^ǂݏoĕ\܂B                      *
*    xp  : fBXvCW̗()Jnʒu                                    *
*    yp  : fBXvCW̍s(c)Jnʒu                                    *
*    c   : R[h(JISR[h)w肷A'F'Ȃ0x3727                     *
*    ans : 0=I                                                          *
*          1=t@CI[vG[(t@C݂Ȃ)                  *
*******************************************************************************/
uint16_t IMG_PutcK(uint16_t xp, uint16_t yp, uint16_t c)
{
     struct SDFILE_OBJECT fds ;
     int8_t   b8 , b12 ;
     uint8_t  i, pix, x, y ;
     char     f[18] ;
     uint16_t ans ;
     uint32_t fp ;

     // tHgf[^̈ʒuvZ
     x = (uint8_t)((c & 0xFF00) >> 8) ;
     y = (uint8_t)(c & 0x00FF) ;

     fp = ((x - 0x21) * 0x5E) + (y - 0x21) ;
     fp = (fp * 18) + 0x78 ;
     // tHgt@C̓Ǎ݃I[v
     ans = SD_Open(&fds,"SHINOME.PDB",O_READ) ;
     if (ans == 0) {
          // tHgf[^̏ꏊ܂ŃV[N
          SD_Seek(&fds,fp,1) ;
          // 1ǂݍ
          SD_Read(&fds,f,18) ;
          pix = 0 ;
          b8  = 7 ;
          b12 = 0 ;
          x  = xp ;
          y  = yp ;
          for (i=0 ; i<144 ; i++) { // 12x12hbg[v
               if (((f[pix] >> b8) & 0x01) == 1) LCD_PutPixel(x,y) ;       // 1hbg`
               b8-- ;
               if (b8 < 0) {
                    // 8rbgo͂ÃoCg
                    b8 = 7 ;
                    pix++ ;
               }
               x++ ;
               b12++ ;
               if (b12 >= 12) {
                    // PQrbgo͂A̍s
                    b12 = 0 ;
                    x = xp ;
                    y++ ;
               }
          }
          ans = 0 ;
          // t@C̃N[Y
          SD_Close(&fds) ;
     } else {
          // t@C̃I[vG[
          // t@C݂ȂꍇG[łB
          ans = 1 ;
     }
     return ans ;
}
/*******************************************************************************
*  ans = IMG_PutsK(xp,yp,*s)                                                   *
*    w肳ꂽʒuɊ(12x12)`悳鏈                         *
*    xp  : fBXvCW̗()Jnʒu                                    *
*    yp  : fBXvCW̍s(c)Jnʒu                                    *
*    *s  : \镶w肵܂(̍ŌnullłȂ΂Ȃ܂)  *
*    ans : 0=I                                                          *
*          1=t@CI[vG[(t@C݂Ȃ)                  *
*******************************************************************************/
uint16_t IMG_PutsK(uint16_t xp, uint16_t yp, uint16_t *s)
{
     int ans ;

     while(*s) {
          ans = IMG_PutcK(xp,yp,*s++) ;
          if (ans != 0) break ;
          xp = xp + 13 ;
     }
     return ans ;
}

