/*******************************************************************************
*  skSDlib.h - MMC/SDC̃ANZXs֐̃wb_t@C                     *
*                                                                              *
* ============================================================================ *
*   VERSION  DATE        BY             CHANGE/COMMENT                         *
* ---------------------------------------------------------------------------- *
*   1.00     2012-04-30  ޒH[     Create                                 *
*   2.00     2016-02-29  ޒH[     FlashAiriSDIO@\ꕔΉɂύX  *
*   4.00     2017-02-22  ޒH[     XC16ƕI[vɑΉ           *
*   4.10     2017-04-01  ޒH[     FlashAiriSDIO֘AŏC              *
*   4.11     2019-05-27  ޒH[     PIC24FΉ                             *
*   5.00     2019-06-04  ޒH[     ŏǂݏo֐̒ǉ     *
*******************************************************************************/
#ifndef _SKSDLIB_H_
#define _SKSDLIB_H_

// __delay_ms__delay_usׂ̈ɕKv
#if defined(__PIC24E__) || defined(__PIC24F__)
 #ifndef FCY
  // Unless already defined assume 60MHz(60MIPS) system frequency
  #define FCY 60000000UL      // Fosc/2(60MIPS)
  #include <libpic30.h>
 #endif
#else
 // PIC12F PIC16F PIC18F p
 #ifndef _XTAL_FREQ
  // Unless already defined assume 32MHz system frequency
  #define _XTAL_FREQ 32000000 // gpPICɂ蓮glݒ肷
 #endif
#endif


////////////////////////////////////////////////////////////////////////////////
// roh֘A

#define CS     LATCbits.LATC2           // J[hIM

////////////////////////////////////////////////////////////////////////////////
// llb^rcbANZX֘A

#define CMD0   0x00                     // J[hւ̃ZbgR}h
#define CMD1   0x01                     // MMCւ̏R}h
#define CMD8   0x08                     // d̊mFSDC̃o[W`FbN
#define CMD12  0x0C                     // f[^Ǎ݂~R}h
#define CMD13  0x0D                     // ݂̏Ԃ₢킹R}h
#define CMD16  0x10                     // ubNTCY̏lݒR}h
#define CMD17  0x11                     // VOubNǍݗvR}h
#define CMD24  0x18                     // VOubNݗvR}h
#define ACMD41 0x29                     // SDCւ̏R}h
#define CMD55  0x37                     // ACMD41/ACMD23ƃZbgŎgpR}h
#define CMD58  0x3A                     // OCR̓ǏoR}h

#define SECTER_BYTES  512               // PZN^̃oCg

////////////////////////////////////////////////////////////////////////////////
// e`s֘A

#define O_READ        0x01              // t@C̓Ǎ݃I[v
#define O_RDWR        0x02              // t@C̓Ǎ݂Ə݃I[v
#define O_APPEND      0x04              // t@C̒ǉ݃I[v

// t@C̃ANZX
struct SDFILE_OBJECT {
     unsigned int  Oflag ;              // ANZXI[vtOۑ
     unsigned int  DirEntryIndex ;      // fBNgGǧꏊ̈ʒu
     unsigned long FileSize ;           // t@C̃TCY
     unsigned long FileSeekP ;          // t@C̎ǂݏoʒu
     unsigned long AppendSize ;         // ǉ݂t@C̃TCY
     unsigned long FirstFatno ;         // f[^i[FATԍ
     unsigned long NowFatno ;           // ݓǂݏoFATԍ&tO
} ;

// e`st@CVXe(FAT12/FAT16)̃p[^\(512oCg)
struct FAT_PARA {
     unsigned char jump[3] ;            // u[gp̃WvR[h
     unsigned char oemId[8] ;           // tH[}bg̃{[
     unsigned int  BytesPerSector ;     // PZN^̃oCgAʏ512oCg
     unsigned char SectorsPerCluster ;  // PNX^̃ZN^
     unsigned int  ReservedSectorCount ;// u[gZN^ȍ~̗\̈̃ZN^
     unsigned char FatCount ;           // FAT̑g(obNAbvFAT)Aʏ͂Qg
     unsigned int  RootDirEntryCount ;  // fBNg̍쐬\Aʏ512
     unsigned int  TotalSectors16 ;     // S̈̃ZN^[(FAT12/FAT16p)
     unsigned char MediaType ;          // FAT̈̐擪̒lAʏ0xF8
     unsigned int  SectorsPerFat16 ;    // PgFAT̈悪߂ZN^(FAT12/FAT16p)
     unsigned int  SectorsPerTrack ;    // PgbÑZN^
     unsigned int  HeadCount ;          // wbh
     unsigned long HidddenSectors ;     // BꂽZN^
     unsigned long TotalSectors32 ;     // S̈̃ZN^[(FAT32p)
     unsigned long SectorsPerFat32 ;    // PgFAT̈悪߂ZN^(FAT32p)
     unsigned int  FlagsFat32 ;         // FAT̗L̏tO
     unsigned int  VersionFat32 ;
     unsigned long RootDirClusterFat32 ;// fBNg̃X^[gNX^(FAT32p)
     unsigned char Dumy[6] ;
     unsigned char FileSystemType[8] ;  // FAT̎("FAT12/16")(FAT3220oCgɗL)
     unsigned char BootCode[448] ;      // u[gR[ḧ
     unsigned char BootSectorSig0 ;     // 0x55
     unsigned char BootSectorSig1 ;     // 0xaa
#if defined __XC32__ || defined __XC16__
} __attribute__ ((packed)) ;
#else
} ;
#endif

// fBNgGg[̍\(32oCg)
struct DIR_ENTRY {
     unsigned char FileName[11] ;       // t@C(8)+gq(3)
     unsigned char Attributes ;         // t@C̑
     unsigned char ReservedNT ;         // Windows NT p \̈
     unsigned char CreationTimeTenths ; // t@C쐬Ԃ1/10bPʂ킷
     unsigned int  CreationTime ;       // t@C̍쐬(hhhhhmmmmmmsssss)
     unsigned int  CreationDate ;       // t@C̍쐬(yyyyyyymmmmddddd)
     unsigned int  LastAccessDate ;     // ŏĨANZX
     unsigned int  FirstClusterHigh ;   // f[^i[FATԍʂQoCg
     unsigned int  LastWriteTime ;      // ŏĨt@Cݎ
     unsigned int  LastWriteDate ;      // ŏĨt@Cݓ
     unsigned int  FirstClusterLow ;    // f[^i[FATԍʂQoCg
     unsigned long FileSize ;           // t@C̃TCY
} ;

////////////////////////////////////////////////////////////////////////////////
// ̑

typedef union {
    struct {
        unsigned seqwrite : 1;     // SD_SEQWrite()֐gpĂ
        unsigned seqread  : 1;     // SD_SEQRead()֐gpĂ
        unsigned          : 6;     // \
    } ;
    struct {
        unsigned seq_area : 2;     // SD_SEQWrite/Read֐̃tOGA
        unsigned          : 6;     // \
    } ;
    unsigned value;
} FLAG_t ;
FLAG_t flag_bits ;

////////////////////////////////////////////////////////////////////////////////
// ֐̃vg^Cv錾

int SD_Init() ;
int SD_Open(struct SDFILE_OBJECT *fp,const char *filename,int oflag) ;
void SD_Close(struct SDFILE_OBJECT *fp) ;
int SD_Flush(struct SDFILE_OBJECT *fp) ;
int SD_Write(struct SDFILE_OBJECT *fp,const char *buf,int nbyte) ;
int SD_SEQWrite(struct SDFILE_OBJECT *fp,const char *buf,int nbyte) ;
int SD_Read(struct SDFILE_OBJECT *fp,char *buf,int nbyte) ;
int SD_SEQRead(struct SDFILE_OBJECT *fp,char *buf,int nbyte) ;
int SD_fGets(struct SDFILE_OBJECT *fp,char *buf,int nbyte) ;
unsigned long SD_Size(struct SDFILE_OBJECT *fp) ;
unsigned long SD_Position(struct SDFILE_OBJECT *fp) ;
unsigned long SD_Seek(struct SDFILE_OBJECT *fp,unsigned long offset,int sflag) ;

// skiSDIOlibłȉ̊֐𗘗p̂Œǉ  Rev2.00/4.10
extern char MMCbuffer[SECTER_BYTES] ;
int ready_check() ;
void cs_select(int flag) ;
int send_command(unsigned char cmd, unsigned long arg) ;


#endif
